<?php
/* Copyright (C) 2003      Rodolphe Quiedeville <rodolphe@quiedeville.org>
 * Copyright (C) 2004-2005 Laurent Destailleur  <eldy@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * or see http://www.gnu.org/
 *
 * $Id: pdf_adytek.modules.php,v 1.12 2005/02/19 14:59:38 eldy Exp $
 * $Source: /cvsroot/dolibarr/dolibarr/htdocs/includes/modules/facture/pdf_adytek.modules.php,v $
 *
 */

/**	    \file       htdocs/includes/modules/recap-facture/pdf_recap_expressiv.modules.php
		\ingroup    facture
		\brief      Fichier de la classe permettant de gnrer des rcapitulatif de facture
		\author	    MESSIN Enguerrand
		\version    $Revision: 1.00 $
*/


/**	    \class      pdf_expressiv
		\brief      Fichier de la classe permettant de gnrer des rcapitulatif de facture
*/
require_once DOL_DOCUMENT_ROOT.'/includes/modules/recap-facture/ModelePdfRecap.class.php';


class pdf_recap_expressiv extends ModelePdfRecap {

  function pdf_recap_expressiv($db=0)
    {
      $this->db = $db;
      $this->description = "Recapitulatif Facturation , Modele 2m-services (NumFac,Ref Contact,Desc Contact,Prix Vente, Montant HT,A payer) </BR>
	Attention !! Il est ncessaire de creer un nouveau type de contact : </BR>
	 -element->facture,source->external,code->DESTINATAIRE";
    }

   function write_pdf_file($socid)
    {
      global $user,$langs,$conf;
      
        $langs->load("main");
        $langs->load("bills");
        $langs->load("products");

      $soc = new Societe($this->db,"",$socid);
      $soc->fetch($socid);
        if ($conf->societe->dir_output)
	{

			$forbidden_chars=array("/","\\",":","*","?","\"","<",">","|","[","]",",",";","=");
			$facref = str_replace($forbidden_chars,"_",$soc->id);
			$dir = $conf->societe->dir_output . "/" . $socid . "/" ;
			$file = $dir .$socid . ".pdf";

	  if (! file_exists($dir))
	    {
	      umask(0);
	      if (! mkdir($dir, 0755))
		{
                    $this->error=$langs->trans("ErrorCanNotCreateDir",$dir);
                    return 0;
		}
	    }

	  if (file_exists($dir))
	    {
                // Initialisation facture vierge
	      $pdf=new FPDF('P','mm','A4');
	      $pdf->Open();
	      $pdf->AddPage();

	      $this->_pagehead($pdf, $soc);

	      $pdf->SetTitle($soc->id);
                $pdf->SetSubject($langs->trans("FacSum"));
                $pdf->SetCreator("EXPRESSIV Dolibarr ".DOL_VERSION);
	      $pdf->SetAuthor($user->fullname);
              $pdf->SetMargins(10, 10, 10);
              $pdf->SetAutoPageBreak(1,0);
	      $tab_top = 60;
	      $tab_height = 180;

	      

	      $pdf->SetFillColor(240,240,240);

	      $pdf->SetTextColor(0,0,0);
	      $pdf->SetFont('Arial','', 7);

	      $pdf->SetXY (10, $tab_top + 5 );

	      $iniY = $pdf->GetY();
	      $curY = $pdf->GetY();
	      $nexY = $pdf->GetY();
		//Recuperation des factures impays
		//$soc->fetch($socid);
		$facimp = $soc->factures_impayes();
	      	$nblignes = sizeof($facimp);
		$pdf->line(10, $curY, 200, $curY );
		$TotalHT = 0;
		$TotalPaiement = 0;
		$TotalTVA = 0;
	      for ($i = 0 ; $i < $nblignes ; $i++)
		{
			//Generation de la facture 
			$fac = new Facture($this->db);
			$fac->fetch($facimp[$i]);
			//Recuperation du contact
			$idcontact=$fac->getIdContact("external","DESTINATAIRE");
			//On prend le premier
			$contact=new Contact($this->db);
			$contact->fetch($idcontact[0]);
			//Calcul deja paya
			$Paiement = round(($fac->getSommePaiement()/1.196)*100)/100;
			$Reste = $Paiement-$fac->total_ht;
			//cALCUL DU TOTALHT 
			$TotalHT +=$fac->total_ht;
			$TotalPaiement += $fac->getSommePaiement();
			$TotalTVA += $fac->total_tva;
		  $curY = $nexY;
		  $total = $fac->total;

		  $pdf->SetXY (10, $curY );
		  $pdf->SetFont('Arial','B', 7);
		  $pdf->MultiCell(20, 5, $fac->ref, 0, 'C', 0);

                  $pdf->SetFont('Arial','', 7);
		  $nexY = $pdf->GetY();

		  $pdf->SetXY (30, $curY );
		  $pdf->MultiCell(20, 5, $contact->id, 0, 'C', 0);
                  $pdf->SetFont('Arial','', 7);
		  $pdf->SetXY (50, $curY );
		  $pdf->MultiCell(20, 5, strftime("%d/%m/%Y", $fac->date), 0, 'C', 0);

		  $pdf->SetXY (70, $curY );
		  $pdf->MultiCell(30, 5, $contact->cp."-".$contact->ville, 0, 'L', 0);

		  $pdf->SetXY (100, $curY );
		  $pdf->MultiCell(40, 5, $contact->nom, 0, 'L', 0);

		  $pdf->SetXY (140, $curY );
		  $pdf->MultiCell(20, 5, $fac->total_ht, 0, 'R', 0);

		  $pdf->SetXY (160, $curY );
		  $pdf->MultiCell(20, 5, $Paiement, 0, 'R', 0);

		  $pdf->SetXY (180, $curY );
		  $pdf->MultiCell(20, 5, $Reste, 0, 'R', 0);

		  if ($nexY > ($tab_top+$tab_height-10) && $i < $nblignes - 1)
		    {
		      $this->_tableau($pdf, $tab_top, $tab_height, $nexY);
		      $this->_pagefoot($pdf, $soc);
		      $pdf->AliasNbPages();
		      $pdf->AddPage();
		      $nexY = $iniY;
		      $this->_pagehead($pdf, $fac);
		      $pdf->SetTextColor(0,0,0);
		      $pdf->SetFont('Arial','', 7);
		    }
		}

	      $this->_tableau($pdf, $tab_top, $tab_height, $nexY);

		/* ******************************
			TABLEAU TOTAUX
		   ******************************
		*/
	      $tab2_top = $tab_top+$tab_height;
	      $tab2_lh = 7;
	      $tab2_height = $tab2_lh * 3;

	      $pdf->SetFont('Arial','', 9);

	      $pdf->Rect(132, $tab2_top, 68, $tab2_height);

	     $pdf->line(132, $tab2_top + $tab2_height - ($tab2_lh*3), 200, $tab2_top + $tab2_height - ($tab2_lh*3) );
	      $pdf->line(132, $tab2_top + $tab2_height - ($tab2_lh*2), 200, $tab2_top + $tab2_height - ($tab2_lh*2) );
	      $pdf->line(132, $tab2_top + $tab2_height - $tab2_lh, 200, $tab2_top + $tab2_height - $tab2_lh );


	      $pdf->line(174, $tab2_top, 174, $tab2_top + $tab2_height);

	      $pdf->SetXY (132, $tab2_top + 0);
	      $pdf->MultiCell(42, $tab2_lh, "Total HT", 0, 'R', 0);

	      $pdf->SetXY (132, $tab2_top + $tab2_lh);
	      $pdf->MultiCell(42, $tab2_lh, "Total TVA", 0, 'R', 0);

	      $pdf->SetXY (132, $tab2_top + ($tab2_lh*2));
	      $pdf->MultiCell(42, $tab2_lh, "Total TTC", 1, 'R', 1);

	      $pdf->SetXY (132, $tab2_top + ($tab2_lh*3));
	      $pdf->MultiCell(42, $tab2_lh, "Total Paiement", 1, 'R', 1);

	      $pdf->SetXY (132, $tab2_top + ($tab2_lh*4));
	      $pdf->MultiCell(42, $tab2_lh, "Net  Payer", 1, 'R', 1);

	      $pdf->SetXY (174, $tab2_top + 0);
	      $pdf->MultiCell(26, $tab2_lh, price($TotalHT), 0, 'R', 0);

	      $pdf->SetXY (174, $tab2_top + $tab2_lh);
	      $pdf->MultiCell(26, $tab2_lh, price($TotalTVA), 0, 'R', 0);

	      $pdf->SetXY (174, $tab2_top + ($tab2_lh*2));
	      $pdf->MultiCell(26, $tab2_lh, price($TotalHT+$TotalTVA), 1, 'R', 1);

	      $pdf->SetXY (174, $tab2_top + ($tab2_lh*3));
	      $pdf->MultiCell(26, $tab2_lh, price($TotalPaiement), 1, 'R', 1);

	      $pdf->SetXY (174, $tab2_top + ($tab2_lh*4));
	      $pdf->MultiCell(26, $tab2_lh, price(($TotalHT+$TotalTVA)-$TotalPaiement), 1, 'R', 1);

		//Notes
/*		$pdf->SetFont('Arial','I',7);
		$pdf->SetXY(10, $tab2_top);
		$note = "Note : ".$fac->note;
		$pdf->MultiCell(110, 3, $note, 0, 'J');

		//Affichage des Informations complémentaires
		$pdf->SetFont('Arial','I',7);
		$pdf->SetXY(10, $tab2_top+12);
		$note = "En cas de paiement anticipe, aucun escompte n'est accorde.\nEn cas de retard de paiement les penalites seront calcules a partir du tauxd'interet legal.\nPaiement a reception.";
		$pdf->MultiCell(110, 3, $note, 0, 'J');
		$pdf->SetXY(15, $tab2_top+26);
		$pdf->MultiCell(110, 3, "Le __/__/____ a _____________________", 0, 'J');
		$pdf->SetXY(80, $tab2_top+26);
		$pdf->MultiCell(110, 3, "Signature et cachet de l'etablissement.", 0, 'J');
		*/
              $this->_pagefoot($pdf, $propale);
              $pdf->AliasNbPages();

	      $pdf->Close();


	      $pdf->Output($file);

          return 1;
	    }
	}
}



///////////////////////////////
  function _tableau_compl(&$pdf, $fac)
    {
      $tab3_top = 240;
      $tab3_height = 18;
      $tab3_width = 60;
      
      $pdf->Rect(10, $tab3_top, $tab3_width, $tab3_height);

      $pdf->line(10, $tab3_top + 6, $tab3_width+10, $tab3_top + 6 );
      $pdf->line(10, $tab3_top + 12, $tab3_width+10, $tab3_top + 12 );
      
      $pdf->line(40, $tab3_top, 40, $tab3_top + $tab3_height );
      
      $pdf->SetFont('Arial','',8);
      $pdf->SetXY (10, $tab3_top - 6);
      $pdf->MultiCell(60, 6, "Informations compl�entaires", 0, 'L', 0);
      $pdf->SetXY (10, $tab3_top );
      $pdf->MultiCell(20, 6, "R�l�le", 0, 'L', 0);
      $pdf->SetXY (10, $tab3_top + 6);
      $pdf->MultiCell(60, 6, "Ch�ue/Virement N", 0, 'L', 0);
      $pdf->SetXY (10, $tab3_top + 12);
      $pdf->MultiCell(20, 6, "Banque", 0, 'L', 0);
    }

  function _tableau(&$pdf, $tab_top, $tab_height, $nexY)
    {
        global $langs;
        $langs->load("main");
        $langs->load("bills");
        
      $pdf->SetFont('Arial','B',8);

      $pdf->SetXY(10,$tab_top);
      $pdf->MultiCell(20,5,$langs->trans("RefBill"),0,'C',1);

      $pdf->SetXY(30,$tab_top);
      $pdf->MultiCell(20,5,"Contact",0,'C',1);

      $pdf->SetXY(50,$tab_top);
      $pdf->MultiCell(20,5,$langs->trans("Date"),0,'C',1);

      $pdf->SetXY(70,$tab_top);
      $pdf->MultiCell(30,5,$langs->trans("Town"),0,'L',1);

      $pdf->SetXY(100,$tab_top);
      $pdf->MultiCell(40,5,$langs->trans("Name"),0,'L',1);

      $pdf->line(140, $tab_top, 140, $tab_top + $tab_height);
      $pdf->SetXY(140,$tab_top);
      $pdf->MultiCell(20,5,$langs->trans("Total"),0,'C',1);

      $pdf->line(160, $tab_top, 160, $tab_top + $tab_height);
      $pdf->SetXY(160,$tab_top);
      $pdf->MultiCell(20,5,$langs->trans("Payments"),0,'C',1);

      $pdf->line(180, $tab_top, 180, $tab_top + $tab_height);
      $pdf->SetXY(180,$tab_top);
      $pdf->MultiCell(20,5,$langs->trans("Due"),0,'C',1);

      $pdf->Rect(10, $tab_top, 190, $tab_height);

    }

  /*
   *
   *
   *
   *
   */
   function _pagefoot(&$pdf, $propale)
   {
    $pdf->SetFont('Arial','I',8);
    // FAC_PDF_ADRESSE  FAC_PDF_TEL

    $pdf->SetFont('Arial','',8);
    $pdf->SetY(-13);
    $pdf->MultiCell(190, 3, FAC_PDF_INTITULE . " - SARL au Capital de " . MAIN_INFO_CAPITAL . " euros - RCS " . MAIN_INFO_RCS." ", 0, 'C');
    $pdf->SetY(-10);
    $pdf->MultiCell(190, 3, "N TVA Intracommunautaire : " . MAIN_INFO_TVAINTRA  , 0, 'C');
    $pdf->SetXY(-10,-10);
    $pdf->MultiCell(10, 3, $pdf->PageNo().'/{nb}', 0, 'R');

    }


  function _pagehead(&$pdf, $soc)
    {
	GLOBAL $langs;
      $tab4_top = 60;
      $tab4_hl = 6;
      $tab4_sl = 4;
      $ligne = 2;
	//*********************LOGO****************************
        if (defined("FAC_PDF_LOGO") && FAC_PDF_LOGO)
        {
            $pdf->SetXY(10,5);
            if (file_exists(FAC_PDF_LOGO)) {
                $pdf->Image(FAC_PDF_LOGO, 10, 5,85.0, 17.0, 'PNG');
            }
            else {
		//Cas Erreur Fichier introuvable
                $pdf->SetTextColor(200,0,0);
                $pdf->SetFont('Arial','B',8);
                $pdf->MultiCell(80, 3, $langs->trans("ErrorLogoFileNotFound",FAC_PDF_LOGO), 0, 'L');
                $pdf->MultiCell(80, 3, $langs->trans("ErrorGoToModuleSetup"), 0, 'L');
            }
        }
        else if (defined("FAC_PDF_INTITULE"))
        {
            $pdf->MultiCell(80, 6, FAC_PDF_INTITULE, 0, 'L');
        }
	//*********************Entete****************************
	//Nom du Document
      $pdf->SetXY(150,5);
      $pdf->SetFont('Arial','B',10);
      $pdf->SetTextColor(0,0,0);
      $pdf->MultiCell(50, 8, "RECAPITULATIF FACTURE", '' , 'L');
	//Num Devis
      $pdf->SetXY(150,10);
      $pdf->SetFont('Arial','B',10);
      $pdf->SetTextColor(0,0,0);
      $pdf->MultiCell(50, 8, "Societe Num : ".$soc->id, '' , 'L');
	//Date Devis
      $pdf->SetXY(150,15);
      $pdf->SetFont('Arial','B',10);
      $pdf->SetTextColor(0,0,0);
      $pdf->MultiCell(50, 8, "Date : " . strftime("%d %b %Y", mktime()), '' , 'L');


	//Definition Emplacement du bloc Societe
	$blSocX=11;
	$blSocY=25;
	$blSocW=50;
	$blSocX2=$blSocW+$blSocXs;

      $pdf->SetTextColor(0,0,0);
	//Adresse Internet
      if (defined("FAC_PDF_WWW")){
	$pdf->SetXY($blSocX,$blSocY);
	$pdf->SetFont('Arial','B',8);
        $pdf->MultiCell($blSocW, 3, FAC_PDF_WWW, '' , 'L');
      }

      if (defined("FAC_PDF_ADRESSE")){
	$pdf->SetFont('Arial','',7);
	$pdf->SetXY($blSocX,$blSocY+3);
        $pdf->MultiCell($blSocW, 3, FAC_PDF_ADRESSE, '' , 'L');
      }

      if (defined("FAC_PDF_ADRESSE2")){
	$pdf->SetFont('Arial','',7);
	$pdf->SetXY($blSocX,$blSocY+6);
        $pdf->MultiCell($blSocW, 3, FAC_PDF_ADRESSE2, '' , 'L');
      }

      if (defined("FAC_PDF_TEL")){
      	$pdf->SetFont('Arial','',7);
	$pdf->SetXY($blSocX,$blSocY+10);
        $pdf->MultiCell($blSocW, 3, "Tel : " . FAC_PDF_TEL, '' , 'L');
      }

      if (defined("FAC_PDF_MEL")){
      	$pdf->SetFont('Arial','',7);
	$pdf->SetXY($blSocX,$blSocY+13);
        $pdf->MultiCell(40, 3, "Email : " . FAC_PDF_MEL, '' , 'L');
      }

      if (defined("FAC_PDF_FAX")){
      	$pdf->SetFont('Arial','',7);
	$pdf->SetXY($blSocX,$blSocY+16);
        $pdf->MultiCell(40, 3, "Fax : " . FAC_PDF_FAX, '' , 'L');
      }

      if (defined("MAIN_INFO_SIRET")){
      	$pdf->SetFont('Arial','',7);
	$pdf->SetXY($blSocX2,$blSocY+10);
        $pdf->MultiCell($blSocW, 3, "SIRET : " . MAIN_INFO_SIRET, '' , 'L');
      }

      if (defined("MAIN_INFO_APE")){
      	$pdf->SetFont('Arial','',7);
	$pdf->SetXY($blSocX2,$blSocY+13);
        $pdf->MultiCell($blSocW, 3, "APE : " . MAIN_INFO_APE, '' , 'L');
      }

      if (defined("MAIN_INFO_TVAINTRA")){
      	$pdf->SetFont('Arial','',7);
	$pdf->SetXY($blSocX2,$blSocY+16);
        $pdf->MultiCell($blSocW, 3, "ICOMM : " . MAIN_INFO_TVAINTRA, '' , 'L');
      }
	
	/**********************************/
	//Emplacement Informations Client
	/**********************************/
	$blClientX=$blSocX2+$blSocW;
	$blClientW=90;

      $pdf->SetTextColor(0,0,0);
      $soc->fetch($socid);

      /*$pdf->SetTextColor(240,240,240);
      $pdf->SetFillColor(240,240,240);
      $pdf->Rect($blClientX, 22, 90, 30);*/
      $pdf->SetTextColor(0,0,0);
	//Nom Client
      $pdf->SetXY($blClientX,$blSocY);
      $pdf->SetFont('Arial','B',8);
      $pdf->MultiCell($blClientW,3, $soc->nom, 0, 'C');
      $pdf->SetFont('Arial','',7);
	$blSocY+=4;
	//Adresse Client
		//Gestion des Retours chariots
		$Out=split("\n",$soc->adresse);
		for ($i=0;$i<count($Out);$i++) {
			$pdf->SetXY($blClientX,$blSocY);
			$pdf->MultiCell($blClientW,5,urldecode($Out[$i]),  0, 'C');
			$blSocY+=3;
		}
      $pdf->SetXY($blClientX,$blSocY);
      $pdf->MultiCell($blClientW,5, $soc->cp . " " . $soc->ville,  0, 'C');


	
      $pdf->SetTextColor(0,0,0);
      $pdf->SetFont('Arial','I',7);
      $titre = "Montants en euros";
      $pdf->SetXY(175,55);
      $pdf->MultiCell($blClientW,5, $titre,  0, 'L');

    }

 //insertion de la variable FAC_PDF_INTITULE  FAC_PDF_MEL  FAC_PDF_WWW   FAC_PDF_LOGO  FAC_CAPITAL_EURO  FAC_PDF_TVA_INTRA    FAC_PDF_RCS

}

?>